{% load custom_tags %}

<div class="col-md-6 col-sm-12">
    <div class="x_panel tile fixed_height_320 overflow_hidden">
        <div class="x_title">
            <h2>{{ titulo }}</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li>
                    <a class="collapse-link"
                        ><i class="fa fa-chevron-up"></i
                    ></a>
                </li>
                <li class="dropdown">
                    <a
                        href="#"
                        class="dropdown-toggle"
                        data-toggle="dropdown"
                        role="button"
                        aria-expanded="false"
                        ><i class="fa fa-wrench"></i
                    ></a>
                    <ul class="dropdown-menu" role="menu">
                        <li><a href="#">Settings 1</a></li>
                        <li><a href="#">Settings 2</a></li>
                    </ul>
                </li>
                <li>
                    <a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_content">
            <canvas
                class="canvasDoughnut"
                id="canvas-{{ titulo|slugify }}"
                style="width: 100%; height: 230px"
            ></canvas>
        </div>
    </div>
</div>
<script type="text/javascript">
    $(document).ready(function () {
        if (typeof (Chart) === 'undefined') {
            return;
        }

        if ($('#canvas-{{ titulo | slugify }}').length) {

            var data = {{ dados | jsonify_queryset:jsonify_queryset_opts | safe}};

            var labels = data.map((elm) => elm['{{ label_field }}']);
            var values = data.map((elm) => elm['{{ value_field }}']);

            if (values.length > 6) {
                var limit = 6;
                while (values[limit] === values[limit-1] && limit > 2) {
                    limit--;
                }
                var old_values = [...values];
                var old_labels = [...labels];
                values = []
                labels = []
                for (var i=0; i<limit; i++) {
                    values[i] = old_values[i];
                    labels[i] = old_labels[i];
                }
                values[limit] = 0;
                for (var j=limit; j<old_values.length; j++) {
                    values[limit] += old_values[j];
                }
                labels[limit] = "Outros";
            }


            var chart_doughnut_settings = {
                type: 'doughnut',
                tooltipFillColor: "rgba(51, 51, 51, 0.55)",
                data: {
                    labels: labels,
                    datasets: [{
                        data: values,
                        backgroundColor: [
                            "#BDC3C7",
                            "#9B59B6",
                            "#E74C3C",
                            "#26B99A",
                            "#3498db",
                            "#f6cd55",
                            "#db700b"
                        ],
                        hoverBackgroundColor: [
                            "#CFD4D8",
                            "#B370CF",
                            "#E95E4F",
                            "#36CAAB",
                            "#49a9ea",
                            "#f6d269",
                            "#e08028"
                        ]
                    }]
                },
                options: {
                    legend: {
                        display: true,
                        position: 'right'
                    },
                    responsive: false
                }
            }

            $('#canvas-{{ titulo|slugify }}').each(function () {

                var chart_element = $(this);
                var chart_doughnut = new Chart(chart_element, chart_doughnut_settings);

            });

        }

    });
</script>
